<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>Calendar</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="canonical" href="https://calendar.heck.app/">
<link rel="stylesheet" href="//heck.app/style.css">
<!-- link rel="icon" href="/calendar.svg" type="image/svg+xml" sizes="any" -->
<style>
table { width: 100%; }
tr { padding: 0; margin: 0; }
td, th { width: 14vmin; border: thin solid black; margin: 0; }
td { height: 15vmin; vertical-align: top; }
td.last-month, td.next-month { visibility: hidden; }
td.today { background-color: #cccccc; }
</style>
<script src="//heck.app/heck.js"></script>
<script>
function days_in(date) {
	switch (date.getMonth()) {
	case 0:	// January
	case 2:	// March
	case 4:	// May
	case 6: // July
	case 7: // August
	case 9: // October
	case 11: // December
		return 31;

	case 3: // April
	case 5: // June
	case 8: // September
	case 10: // November
		return 30;
	}

	/* Februrary */
	var y = date.getFullYear();
	if (y % 4 == 0) {
		if (y % 100 == 0 && y % 400 != 0) {
			return 28;
		}
		return 29;
	}

	return 28;
}

function month_name(date) {
	let names = [ "January", "February", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December" ];
	return names[date.getMonth()];
}

function make_row(today, date) {
	var dom = date.getDate();
	var dow = date.getDay();
	var month = date.getMonth();

	var row = document.createElement("tr");

	for (var i = dom - dow; i < dom - dow + 7; i++) {
		var td = document.createElement("td");
		var day = i;
		if (day < 1) {
			td.className = "last-month";
			day = days_in(date) + day;
		} else if (day > days_in(date)) {
			td.className = "next-month";
			day = day - days_in(date);
		} else if(day == today.getDate()) {
			td.className = "today";
		}
		td.innerHTML = day;
		row.appendChild(td);
	}

	return row;
}

function show_month(date) {
	let MSPERDAY = 86400000;

	var cal = document.getElementById("heck-calendar");
	cal.innerHTML = '';

	var cap = document.createElement("caption");
	cap.innerHTML = month_name(date) + ", " + date.getFullYear();
	cal.appendChild(cap);

	var tr = document.createElement("tr");
	var days = [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ];
	for (var day in days) {
		var th = document.createElement("th");
		th.innerHTML = days[day];
		tr.appendChild(th);
	}
	cal.appendChild(tr);
	
	var cur = new Date(date);
	cur.setDate(1);

	var end = new Date(date);
	end.setDate(days_in(date));

	while (cur.getTime() <= end.getTime()) {
		cal.appendChild(make_row(date, cur));
		cur = new Date(cur.getTime() + (7 * MSPERDAY));
	}
}

function init() {
	//heck("Calendar");

	show_month(new Date());

	window.addEventListener("keydown", function(e) {
	});
}
</script>
</head>
<body onload="init();">
<table id="heck-calendar"></table>
</body>
</html>
